unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses ExRegUtils;

const
  RegPfad = 'Software\ProgSetTest\';

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  WindowState := wsNormal;
  Left := ReadRegInteger(RegPfad + 'Position', 'Left', 40);
  Top := ReadRegInteger(RegPfad + 'Position', 'Top', 40);
  Width := ReadRegInteger(RegPfad + 'Position', 'Width', 600);
  Height := ReadRegInteger(RegPfad + 'Position', 'Height', 400);
  if TWindowState(ReadRegInteger(RegPfad + 'Position', 'WindowState', 0)) = wsMaximized then
    WindowState := wsMaximized;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  WriteRegInteger(RegPfad + 'Position', 'WindowState', Integer(WindowState));
  WriteRegInteger(RegPfad + 'Position', 'Left', RestoredLeft);
  WriteRegInteger(RegPfad + 'Position', 'Top', RestoredTop);
  WriteRegInteger(RegPfad + 'Position', 'Width', RestoredWidth);
  WriteRegInteger(RegPfad + 'Position', 'Height', RestoredHeight);
end;

end.

